commit 22a8cfb1210b0080776756d54fa48e1c119217c2
Merge: 4e60b15 e012eca
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun May 10 12:43:24 2026 -0400

    Merge remote-tracking branch 'refs/remotes/ArrayBolt3/arraybolt3/trixie'

commit e012ecafeb4f74736698ac22b68861af47d44898
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Thu Apr 30 22:17:10 2026 -0400

    Add coding agent guidance

    Based on the below commit:

    commit 38f8354093687d454950e7abefffe999cdbd9ab1
    Author: Claude <noreply@anthropic.com>
    Date:   Mon Apr 27 21:10:25 2026 +0000

        Add AGENTS.md with security design decisions and audit history

        Captures reviewer conclusions from PR #1, architecture invariants,
        and resolved vulnerabilities so future contributors do not re-propose
        changes that have already been evaluated.

        https://claude.ai/code/session_01W6kXMiJ5ULwNV9cega66Dx

commit 4e60b15480c71c3413c384cc9396d010d18634bf
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Apr 8 17:49:53 2026 +0000

    bumped changelog version

commit 160dd48d669c1dbc414a736498b874f5ae4e53b4
Merge: c60c03b 763ba07
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Apr 8 09:58:09 2026 -0400

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 763ba070d290051ccdb53afa79a1698214a7e5da
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Wed Apr 8 01:06:12 2026 -0400

    Misc bugfixes (from Claude Code)

commit c60c03b084473b74fd1a7dc20ec8dfa244d0fedd
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Mar 19 18:29:50 2026 +0000

    bumped changelog version

commit f3e2209ed168d357b8aedec6d7b06c628d0416ae
Merge: a4ef193 20e6fa3
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Mar 15 04:17:55 2026 -0400

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 20e6fa317de015efcd2e385e6a2068f1b63823ae
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Sat Mar 7 20:14:03 2026 -0500

    Add a couple additional tests

commit 1b8d2b3ffde6fa63934a3fadca1dd3293eef81d6
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Fri Mar 6 17:41:45 2026 -0500

    Polish protocol spec, add variable argument count support for messages, allow checking authorization on multiple actions at once, improve test coverage

commit adc565d13830af40ccfa3d1475534a9a6b6a631e
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Tue Mar 3 00:38:16 2026 -0500

    Add multithreading tests

commit 2648332fa06b6cdbac1ad57dedada5aaddf73679
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Mon Mar 2 21:41:41 2026 -0500

    Refactor user account naming mechanism in tests in preparation for implementing better multithreading tests

commit 927a440898af89c99bbc892a3a8a9fb06e1ef4e8
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Sun Mar 1 23:43:43 2026 -0500

    Fix process interruption bug, attempt to fix an intermittent deadlock introduced in the last commit, switch from using select to epoll to handle heavy load better, terminate all actions running through a particular comm socket when that comm socket is destroyed

commit 77eadd36f74725dcd35a86b86d83fc1f42ee2453
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Fri Feb 27 17:21:21 2026 -0500

    Change style of docstring indentation, break control message handler into a separate thread, fix a thread safety bug when destroying a comm socket, document thread safety constraints, fix persistent user handling during a config refresh

commit a4ef1936a9bca635f897027f027cd743ae2a5127
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 27 10:53:44 2026 +0000

    bumped changelog version

commit a449f3f7864882071d8f6b9183b0bf2faf63f0e9
Merge: d1eaaa9 5b83e59
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 27 05:17:12 2026 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 5b83e5984b7da01a295b3c33a432f3f7bcbd5afd
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Wed Feb 25 23:46:16 2026 -0500

    Fix improper permissions on test suite fake privleapd directories

    This unbreaks the test suite in a Kicksecure 18 AppVM under Qubes R4.3.
    (It's probably needed to unbreak the suite on any Kicksecure 18 system
    because of the default umask we use.)

commit b01dea868bdcbe46a8dc9a8449b4f8ef04646805
Author: Aaron Rainbolt <arraybolt3@gmail.com>
Date:   Wed Feb 25 23:45:00 2026 -0500

    Try to set the required permissions on new{uid,gid}map when running tests in a Qubes AppVM

commit d1eaaa9c4b8ef38654e6971bbfc251e32b3d818c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jan 28 06:44:59 2026 +0000

    bumped changelog version

commit 795ecec498b568cbc4bcdee1d7e14bd172c4c359
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jan 28 01:09:58 2026 -0500

    code simplification

commit 1bb09050a2718a7b64980004e3dcf3e77366ac86
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 8 09:43:19 2026 +0000

    bumped changelog version

commit 99f70987be2b5953bc4c16e2746d30f19f843e6d
Merge: 71083cc 1ba2497
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 8 04:11:39 2026 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 1ba249734fdfe1fedf3101e5d20037c8fbf645c6
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 7 20:18:32 2026 -0600

    Prevent locale settings from causing unpredictable privleap action output

commit 71083cc4340941a8fec5026a689ae303bd93a5f1
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 3 13:08:58 2026 +0000

    bumped changelog version

commit 5253fbdf21a8de0fde2fc4cb6804856057abe908
Merge: 8f21399 d33f615
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jan 3 08:03:34 2026 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit d33f61582b719702c6c5cfffa0db1444bfb3b4c8
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Jan 2 12:51:39 2026 -0600

    Allow inhibiting privleapd restart on upgrade

commit 8f213995e4f99e37d30d3070e4b4e90dbb05ad5e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 1 17:13:55 2026 +0000

    bumped changelog version

commit aa4c21f73ac82cf72a41b9efa101e34bfa4e2989
Merge: 2313469 4341686
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 1 12:00:48 2026 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 4341686cee3f99b0c298bc9676802d6b04160d83
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Dec 29 20:55:35 2025 -0600

    Blacken

commit 1f73160ccbf36fc4526bffba5e38cb353e9cfc48
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Dec 29 20:55:28 2025 -0600

    Avoid INFO message about missing /usr/local/etc/privleap/conf.d when running privleapd in --check-config mode

commit 23134698945c4a7b0decafba1d84fb2bf3438ed5
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Dec 28 06:35:59 2025 +0000

    bumped changelog version

commit 137bd48d846e5d5c18214b8ca03fb7d53c8cb5aa
Merge: e8bccf8 f5123a1
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Dec 28 00:46:16 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit f5123a166a6ce5a427a89403b87618582144320b
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Dec 26 15:39:04 2025 -0600

    Update documentation, mostly to explicitly warn against running tests without run_autopkgtest

commit c79637b725abb310e569c455892092a3ebe4e3bf
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Dec 26 15:28:04 2025 -0600

    Add the ability to parse config files in '/usr/local/etc/privleap/conf.d'

commit e8bccf8520c612c5dffb390c3eebe632ada6431c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Dec 3 08:30:23 2025 +0000

    bumped changelog version

commit 46f7612ad94012d0c99ef27e299965a6c5aaf538
Merge: e6a6aa0 5fc5f5d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Dec 2 05:52:39 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 5fc5f5deb160020ae3dbd6053c0117947d36430e
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Nov 26 23:29:40 2025 -0600

    Indentation fixes, poll for control and comm sockets in leaprun and leapctl

commit e6a6aa0535e5fbb83343e49b14e98ff38c94d956
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Nov 19 07:06:51 2025 +0000

    bumped changelog version

commit 9db99f38c67f1ef9cae694d0f41b00f5879371cf
Merge: f92a92d 08fb5f5
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Nov 19 02:06:05 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 08fb5f57e1260b1d96b58dd6a9365886855afae1
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Nov 18 23:37:49 2025 -0600

    Add check for insecure config file permissions

commit d89b3ac336e7343799b06a9a450948e0411362ce
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Nov 18 21:57:15 2025 -0600

    Explicitly drop all supplementary groups

commit 783fce5012f5fd2f29a57bdc5e6cca60cac288fc
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Nov 18 20:58:17 2025 -0600

    Rework leaprun signal handler to reduce the risk of terminate messages not being sent

commit f92a92dbf08b8c86c9845b88f7e988300a270257
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Nov 18 07:23:11 2025 +0000

    bumped changelog version

commit 094f6f1796033ea05a3e5fb93a2be4f52e0bf0d7
Merge: 405ad7b ed781df
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Nov 18 02:12:57 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit ed781df3dbeee4aa6ea1c95c99cb3de789d9b65f
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Nov 16 17:16:39 2025 -0600

    Prune sockets for disallowed users on config reload

commit 50facae84703ee779f9a8fd9db20f02edad8a556
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Nov 16 16:43:15 2025 -0600

    Avoid allowing anyone to run an action that has user/group restrictions for only nonexistent users/groups

commit ddf5e8442f681c4ddb5a12adb57bc2edae8c78d9
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Nov 16 16:09:35 2025 -0600

    Make privleapd pick up changes to group ownership immediately, kick disallowed users who manage to connect to privleapd anyway, minor additional test refactoring (inspired by code from ChatGPT Codex)

commit 911ddeeeec0fe7150dd10663e1925273ef3661ce
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Nov 16 13:09:47 2025 -0600

    Harden umask as defense-in-depth against socket ownership vulnerabilities

commit 62eb599964dd9ade5c4e48131a816cbc355a3044
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Nov 16 13:09:10 2025 -0600

    Fix wrong function call for normalizing a group ID

commit 405ad7b75637498983f228f8c4cf9ed6020c583c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Nov 14 06:56:20 2025 +0000

    bumped changelog version

commit d06f3db017c61f4c1fe52c2be3b7c9326441ee76
Merge: d913bb6 bf27bd5
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Nov 14 01:47:06 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit bf27bd57b256b468f48105a14eaa2834b786b23c
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Nov 13 21:55:55 2025 -0600

    Add username/UID to authorized/unauthorized messages in leaprun, refactor tests to be much easier to work with

commit d913bb6e0948017bc136d171bdfc71fd878f9e03
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Nov 1 08:17:38 2025 +0000

    bumped changelog version

commit 3abcc0823ffac0ec59d5735ffb9244c5ec990b9d
Merge: 09aa71a 43fbac9
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Nov 1 04:01:05 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 43fbac99c4fa6ec9312623d9452312627fa30f45
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Oct 31 13:39:45 2025 -0500

    Fix leaprun documentation

commit 09aa71a4e807d8b78bd70630bd08712d019e4e47
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Sep 19 16:16:03 2025 +0000

    bumped changelog version

commit bc92aae0a5728be364d43198a28335f391b4b278
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Sep 18 10:07:57 2025 -0400

    fix

commit d6b21283e746137673347d70bf373b85be68e615
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Sep 2 15:22:52 2025 +0000

    bumped changelog version

commit d19188544e47e4c12170349448f04c7702688601
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Aug 27 19:28:34 2025 +0000

    bumped changelog version

commit 8e66882a65ba9e6463ccf9c3dfce0a3eceb5c973
Merge: d4ba12e 1b0abc8
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Aug 27 11:27:02 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit 1b0abc87745bae2ee76d5fa2822fa2b7ab871fc2
Merge: 4faee86 d4ba12e
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Aug 26 19:20:19 2025 -0500

    Merge branch 'master' into arraybolt3/trixie

commit d4ba12e285447e578693cbfae5edf775908843a3
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Aug 26 09:13:30 2025 +0000

    bumped changelog version

commit 9a313fbffbd39d63d659fb575bf0b4d8288a2e92
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Aug 26 05:13:29 2025 -0400

    re-generate man pages (generated using "genmkfile manpages")

commit 4faee862c2064aa8db63ca906b671ad76b02d4bc
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Aug 22 19:44:40 2025 -0500

    Add todo

commit 054be3f4cef06393f07788eceaec67b727aa3629
Merge: ba728f4 6e81f21
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Aug 20 08:57:36 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/arraybolt3/trixie'

commit ba728f47f59c669a970d539e9ded1e4ace4ed153
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Aug 20 06:57:28 2025 -0400

    bumped Standards-Version

commit d5b98c4a37bda4f37c28995f8bf394d278d5fe9f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Aug 20 06:25:34 2025 -0400

    readme

commit 6e81f2112b5be0a0f5ad1f78b4732d082ea67f00
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Aug 6 17:58:25 2025 -0500

    Adjustments to pass black, mypy, pylint, and regression tests under Trixie

commit c830986b43780a55b92e9cade5c1228b23ca275d
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Aug 5 22:58:04 2025 -0500

    Port to Trixie.

commit 9f7a3afb78b5518e527f41492e8188a12217d3b6
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jun 14 12:00:35 2025 +0000

    bumped changelog version

commit 60f76a84a27b5fda9f35d9a59a87a0e04a2daf7a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Jun 14 07:58:14 2025 -0400

    readme

commit e28b99a702665ffc893da44eb9473794528155b2
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jun 11 19:15:06 2025 +0000

    bumped changelog version

commit 197e1a3635f58299e9a67e04c742de9b4d9eed1e
Merge: 6b5ea57 736f145
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jun 11 15:12:09 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 736f145b5bb3276c8e76319dbf23772ff31d69cf
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Jun 6 15:46:47 2025 -0500

    Add Group key support for allowed-users section, add privleap group

commit 6b5ea577b68997720e36f826623941f5f31c8485
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue May 20 11:39:46 2025 +0000

    bumped changelog version

commit 6d59a8c9a4a7ba61bdba36d5b1f320fe6b268248
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun May 18 06:59:55 2025 -0400

    minor

commit 073790bfd1055f3235c11fbbbb1647837d8dd19f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun May 18 06:55:30 2025 -0400

    minor

commit c69ed093c4493c6e6f7184db5863ddff092ad1ea
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed May 7 06:40:22 2025 +0000

    bumped changelog version

commit 0f0bd1cc04594f4bc9f7567bad56fb9a64616a1e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed May 7 02:35:09 2025 -0400

    python -su

commit 4cd0c313881584aa7e451cd2ce7f6ce14c81c185
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Apr 19 17:33:12 2025 +0000

    bumped changelog version

commit 01216269e46755d6b9b36b9f5663d90fc1a95573
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Apr 19 13:29:47 2025 -0400

    remove trailing whitespace

commit 6589787ff174998fab6939033787804682f8d542
Merge: f29f3cc 2c50838
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Apr 19 13:28:12 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 2c50838641386556db111b3d646587d47f673cea
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Apr 17 23:30:59 2025 -0500

    Fix buffering issues with stdout/stderr streaming

commit c3fcbf3f5eba7ec3e8c04e0a41a0692c33a1c4ca
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Apr 17 21:34:21 2025 -0500

    Make it possible to interrupt a privleap action

commit f29f3cce79c3e821e21f52c6c5bb182446dabe0e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Apr 9 15:15:39 2025 +0000

    bumped changelog version

commit 0112115f0cddb8e6979f1ead97933460c74a006d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Apr 9 09:48:06 2025 -0400

    newline at the end

commit d8f8e09e020b85451b9be17b0695760715a4136e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Apr 8 14:08:04 2025 +0000

    bumped changelog version

commit 017f899a50e6c3629da259fc327e6f10ceb3bd56
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Apr 8 07:25:15 2025 -0400

    remove trailing spaces

commit 7e203ec5c239dd814e4a4898b4ae40c2b2041689
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Apr 8 07:13:09 2025 -0400

    remove trailing spaces

commit a0cc68dc56c0c601d43570c5327b699bb1564757
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Apr 3 17:01:21 2025 +0000

    bumped changelog version

commit b5f73c41bf86580fc56bee4d34aa8330eb8faad5
Merge: f40a2a4 78b83a9
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Apr 3 12:24:55 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 78b83a9ff22a91c47bab9964e6d8b76672dc5f06
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Apr 2 20:06:28 2025 -0500

    Allow configuring users as "expected disallowed"

commit f40a2a4556c6124dabb75ba593563ce7c72fec9d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 31 10:20:10 2025 +0000

    bumped changelog version

commit b9b43ab51b1ff22ddf0f270d56d9f62fcc6705a4
Merge: 2605f0f fb76cc6
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 31 06:08:10 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit fb76cc6a7683a789ef9d69096a05077350b7ec0f
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Mar 30 15:40:48 2025 -0500

    Add --check switch to leaprun, do some code cleanup

commit 2605f0f3ec7c9dae854c029a569cbf6c3668b39a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Mar 18 10:56:42 2025 +0000

    bumped changelog version

commit 77828a5ce40d1bbc81e39c4dc62949dc6ca33c76
Merge: 4c35d5a e8d7023
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Mar 18 06:48:16 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit e8d7023b44d770d7b9c76ff217b975da0e9d0d05
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Mar 17 21:25:39 2025 -0500

    Fix shim environment bug, add tests to prevent similar bugs in the future

commit 4c35d5a6937f12676c2215d5668e284943c83353
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 17 08:53:20 2025 +0000

    bumped changelog version

commit b5a97dca7dbf2095c94733e36cdb2508b6779ffa
Merge: e6bc770 b9ea564
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 17 02:49:38 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit b9ea564089d3f825a2f08364807dfc1c7c278eb8
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Mar 16 16:36:25 2025 -0500

    More logging improvements

commit e6bc77073686b7c761045556a436ef31684145c5
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Mar 15 10:52:06 2025 +0000

    bumped changelog version

commit 69017c3871df3613c054052fdfad63485b28118f
Merge: ea0de35 abf878d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Mar 15 05:23:14 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit abf878dfe55d49bb930fdbba2ed9542db9d4aa93
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Mar 14 19:03:39 2025 -0500

    Change 'user' to 'account' where appropriate, add usernames to action-related log messages

commit 03a2f1f93fd5d5df339a58a24b6de8106631c73b
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Mar 14 17:06:19 2025 -0500

    Improve shim documentation

commit 159460e1ea722e1b1fc3594c52d9c4715b0dbd5d
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Mar 14 17:02:42 2025 -0500

    pylint override

commit 971bfcf06c9b8b3db5b297dab0d4ebb3607b79ca
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Mar 14 16:57:16 2025 -0500

    Fix umask handling

commit c1e9730e5ff3988db610d5603f1b14d8e16ebd2d
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Mar 14 15:30:49 2025 -0500

    Prevent leapctl services from starting too early

commit ea0de35ec045bd3a6f76614dd2c9114671608eb9
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 10 07:42:11 2025 +0000

    bumped changelog version

commit aaae14df8e1d81dc6cbef3fe883e6e443d5beaab
Merge: 5c7a542 78698e8
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 10 02:32:29 2025 -0400

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 78698e8ae40d2b5ea3e0f11e32f8ffe0b2e6793e
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Mar 7 13:09:36 2025 -0600

    Don't show unnecessary configuration warnings in the middle of a config migration

commit 5c7a5428c9a9edebad37e90ee114c6dad34d7976
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Mar 5 11:14:15 2025 +0000

    bumped changelog version

commit 372443fcb5fc563449655ba27dc4b89623391acd
Merge: 50fc358 a22b63d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Mar 5 05:46:51 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit a22b63d4190cf8b52fb8727560f4113f80da36b2
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Mar 4 17:09:39 2025 -0600

    Don't trigger login sessions when running actions

commit e7b396d6edc693eb42039f3191e2103ac137312d
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Mar 3 20:55:33 2025 -0600

    black reformatting

commit b4a84a8660fe8a5380e42b9df930ac718cb2dd34
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Mar 3 20:55:04 2025 -0600

    Add auto leapctl service restart except in cases where a user is not permitted to have a comm socket, update docs

commit 0db59e476e606481b979331060a3cc53cd73da99
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Mar 3 20:07:42 2025 -0600

    Support end-of-options parameter in leaprun

commit 61da84d033c23c74840ae953409a2c09475a0b9c
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Mar 3 20:01:27 2025 -0600

    Use end-of-options when calling bash from privleapd

commit 50fc35853209716c601f70b7f6a044476a62c224
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 3 11:24:44 2025 +0000

    bumped changelog version

commit bb63601cd324ccd1eb8871c6d18a0938a5eca776
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 3 06:24:06 2025 -0500

    output

commit b5602c0cd2752930698d99c52f12ce92ab94e8ae
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 3 10:55:27 2025 +0000

    bumped changelog version

commit 2170f8cdb6804c766ed66b8e5b355dc25a5eddf0
Merge: 3df7b50 6de291f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Mar 3 05:41:19 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 6de291fbae62b3ba7a0a879315feadb255c16f27
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Mar 2 16:41:47 2025 -0600

    Format with `black -l80`

commit 72f67b179aa3e735ebbf30f890cc0d7c11db5454
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Mar 2 16:13:57 2025 -0600

    Make PAM environment variable integration work

commit f84caaa87e5cd68a97260ad558eba0115be0717c
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Mar 2 14:57:08 2025 -0600

    wip: add PAM integration, refactor to make pylint happier

commit 88c067ca4c2c3d0b2ea8f2a24720479feb4308d5
Merge: 4de00cb 3df7b50
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Feb 25 20:46:47 2025 -0600

    Merge branch 'master' of github.com:Kicksecure/privleap

commit 4de00cb88b532741d21c481e20c1a7386d71fcd6
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Feb 24 18:52:04 2025 -0600

    Fix config example in privleapd.conf.d(5) manpage

commit 3df7b5098eb5da66355b02b046b86ac4ec556430
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Feb 24 07:48:03 2025 +0000

    bumped changelog version

commit 6154c25dc88d1b66f6db272ac79a84795781fb6b
Merge: 905e31e 82b509c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Feb 24 01:23:27 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 82b509c719f8d227b923a8d4ba328a994ea61e05
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 22 21:20:24 2025 -0600

    Fix documentation

commit 415190bed64add132fdb38e886ce868286c4da77
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 22 19:15:18 2025 -0600

    Require all rules to configure authorized users and groups explicitly

commit 905e31e0d70a143e0607a48b54e6d718afee5f4e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 21 09:55:19 2025 +0000

    bumped changelog version

commit 2769869dcd85fe77591b6ed07df9d0bfcb5dc03e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 21 04:54:50 2025 -0500

    lintian

commit 37fd03c98df9071c011cbae9f72c73fbb311072c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 21 09:47:39 2025 +0000

    bumped changelog version

commit b44d18e8ea29b217b5670d0db06ac806f12b3b3c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 21 04:47:01 2025 -0500

    comment

commit e9273b36a015c1c7471c33236012bef5dc297284
Merge: 75d67bb dd77678
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 21 04:08:23 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit dd776782aedf176b3f2538e8b8b78db73504ba43
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 20 22:56:22 2025 -0600

    Don't fail hard when upgrading privleap on a system with invalid config

commit b482a05a1970b1be0bbad784753a1019730e0b0c
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 20 22:39:33 2025 -0600

    Require action headers to be explicitly marked as such, test refactoring

commit e8e00710d4d085f17183a32ec018c949184fcba2
Merge: 29580c1 75d67bb
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 20 21:45:09 2025 -0600

    Merge branch 'master' of github.com:Kicksecure/privleap

commit 29580c1bc4991a87f03bdc7fc92738b36371ca37
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 20 21:28:17 2025 -0600

    Don't (re)start privleapd if configuration is invalid, warn about invalid config on installation, prevent dh_installsystemd conflicts

commit 4996e3980c9512295aa9ab1dac2eaf66e14e9f1b
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 20 19:31:29 2025 -0600

    Require debian-archive-keyring in run_autopkgtest, remove bad helper-scripts reference, tidy up autopkgtest dep list

commit 7422b104f19e1ea3d067c63af69aa0efca70690c
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 20 18:21:07 2025 -0600

    Add systemctl reload support to privleapd

commit 4a6e6ba7f1eb45ce9171391037184530f3219733
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 20 18:04:44 2025 -0600

    Add regression tests for config reload support, fix minor issues with log messaging in privleapd

commit 75d67bb8cf86accf3e60cb904a7de1d0a61a5806
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 20 05:14:34 2025 +0000

    bumped changelog version

commit 8e641857d09301d35718cfda1ac56c8a5b3b848d
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 20 00:14:33 2025 -0500

    re-generate man pages (generated using "genmkfile manpages")

commit 841eb30a3e1d8ced6c7cf6e4a4009209ff6ea482
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 23:13:02 2025 -0600

    Implement restartless config reload (wip, needs regression tests), refactor for maintainability

commit a97da79015701416d34fc5a5de422df4aa0147eb
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Feb 19 22:59:03 2025 -0500

    debugging

commit 087563c57023f70f3919b47f07a0268f92858053
Merge: 87c72c2 d6bbdc8
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Feb 19 22:56:45 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit d6bbdc8fde6f5f09d81fa454a434a5c26643534f
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 15:36:03 2025 -0600

    Improve config parser error messaging and make parser more strict

commit 148d58cb96f2cb90c6b053908a1dddb6d73007e2
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 13:31:45 2025 -0600

    Avoid printing things like ANSI escape sequences

commit 0d5dd5e0c3737f013dd15d7c0dd3bab484abbd94
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 12:45:06 2025 -0600

    Avoid trying to start privleapd-run-sensitive testing before privleapd starts

commit 54837d313b97f78f231c4fdc651e5557b0e1e3d6
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 10:51:19 2025 -0600

    Echo bugfixes/refactor in run_autopkgtest, forbid running run_autopkgtest as root

commit b4e55c8e17294dd789019f2329d62529d9437eb0
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 10:44:04 2025 -0600

    Only start privleapd once during installation

commit 7d6235660c1c00144484a151c9e44aaba6129e10
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 10:34:11 2025 -0600

    Prevent weird failures when purging and reinstalling on Qubes OS Debian VMs

commit 6eed6e0993e6b25a78a0a0f847bca5a9b88075e2
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Feb 19 00:28:10 2025 -0600

    Add help info to privleapd, add tests for privleapd help and invalid argument handling

commit ea8b2ab439105cf81f5e589159f2e7ff997c4d11
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Feb 18 23:54:56 2025 -0600

    Report line number for duplicate action config errors

commit 62bf39591acbc7478f07fdbf0644d10b68d010a3
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Feb 18 23:35:18 2025 -0600

    Refactoring, make config check more machine-readable

commit 159eba7caef5939e32259a755d564f11d4139c19
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Feb 18 22:05:31 2025 -0600

    Fix run_autopkgtest argument parsing

commit 560bfb1151fc4cfe45534f1cd2d9e8f883062f74
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Feb 18 21:43:45 2025 -0600

    Add help to run_autopkgtest, refactor argument parsing slightly

commit 2238230c1833f49a40dd8d14ba00467861ee6d74
Merge: 33ff309 87c72c2
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Feb 18 21:12:11 2025 -0600

    Merge branch 'master' of github.com:Kicksecure/privleap

commit 33ff309cf7cebf50c4a06b7cbc6355c9630ed10e
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Feb 17 23:36:39 2025 -0600

    Prevent config files from having duplicate keys in action definitions

commit adad988f33965d42074865d7472056cf257f816f
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Feb 17 23:05:08 2025 -0600

    Prevent config lines from showing up before config headers

commit 73b8378390fbbf355d91e99986d61cf216a5a418
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Feb 17 22:35:05 2025 -0600

    Prevent blank or comment-only config files from crashing privleapd

commit 17d4caa0a84499559c8f18dbd90076ef0172501d
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Feb 17 22:20:59 2025 -0600

    Avoid trying to (re)start the privleap service in the postinst if systemctl isn't executable

commit cbe10804c4d7f9a4bf10aae33663377969a17481
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Feb 17 21:55:01 2025 -0600

    Process the config files in a deterministic order

commit 87c72c21ec2728ff18c2b51a2dbc68a48a70105f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Feb 17 12:28:12 2025 +0000

    bumped changelog version

commit eed911a8097cc09ff09dc422e0f9f62eb4ce2849
Merge: 023462f 46f1ad0
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Feb 17 07:10:51 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 46f1ad00587cd1b34ee43fd14abf55b271cf8182
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Feb 16 13:36:29 2025 -0600

    Configure to start before basic.target is reached

commit 6a010d2615e98ad4ad953c7a6f7c4b32322d1971
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 15 23:21:58 2025 -0600

    Add manpages, remove redundant and outdated bits of documentation

commit 404a31e2fdf7b75b068472180eadd865e45f33ab
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 15 21:49:24 2025 -0600

    Improve config file diagnostics, make pylint happy

commit a9e7dd4bfc84bf6368a0241fe808f1134991ffd2
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 15 21:29:24 2025 -0600

    Slightly rearchitecture config file loading, add error messages with filenames and line numbers when invalid config is hit

commit 27fb000a8415e00d25809a61b9739f6e1affc480
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 15 20:25:24 2025 -0600

    Fix duplicate action name check

commit 411c933d111dfbd524083b185bfdeba40c01d956
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 15 19:24:24 2025 -0600

    Add automated tests for -C and --check-config options

commit 93db6a41105da94786d748fda047feb12e46ba01
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 14 17:46:58 2025 -0600

    Add config check mode to privleapd

commit 490139a0210ba9d43f0407b674326c7765f18bcc
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 14 17:35:20 2025 -0600

    Document --reset-tarball argument to run_autopkgtest

commit d99b518e26003df2289a81457a0982f2b97ada0c
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 14 17:23:34 2025 -0600

    Add easy autopkgtest dependency installation, misc run_autopkgtest improvements

commit f01e6f17fd8a5bc80c057f0e82b543d1451df35d
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 14 17:06:01 2025 -0600

    Don't hardcode distribution name in autopkgtest code

commit 2470b2c4ff664231b19c44fb112ecd0b01993786
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 14 16:30:40 2025 -0600

    Remove dependency on helper-scripts

commit 8ba3651866a2909b2b09ca8d251a5ce0d2a73bcc
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 14 00:52:44 2025 -0600

    Fix postinst behavior, create run_autopkgtest script, fix bad instructions in config readme

commit 023462f374baa8877dd981357bb7176e043cbde8
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 14 00:07:07 2025 +0000

    bumped changelog version

commit aa7a06ac320584075b716d29a770bc94e8b0a712
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 19:02:10 2025 -0500

    fix

commit d4430b86dd3487c8c9ff001ae351c63d9bcc985b
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 19:00:58 2025 -0500

    local

commit 59c6df76f1417123d4943f1e53beb971ce57e402
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 19:00:10 2025 -0500

    code simplification

commit f04a8fc401c3d8fda420fa8fc6f333ebcc62aa64
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:58:05 2025 -0500

    re-apply improvements

commit 385e280351e257fdbe0ad4ee30e1bdbcf04f115d
Merge: d69718b e5224a2
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:56:10 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit d69718b8fea71b1a950692b17d41dcf4d8967b71
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:45:57 2025 -0500

    description

commit 75ec75c6bdc13e2c5fe8ccd2275279fda140d437
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:45:29 2025 -0500

    chmod +x

commit c830e6620eb913eaa415a7ca982dfe85ba0c33e3
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:45:04 2025 -0500

    code simplification

commit 10cf534141934671fb56eb6be2bd4ee9a9bceae4
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:43:33 2025 -0500

    refactoring

commit 9cefc978f37127cdfdbc501746b020d65a60c82e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:42:47 2025 -0500

    emulate debhelper more

commit 5eb791bf912b2d5589c99cd6fe1ec95bda69ecb2
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:42:02 2025 -0500

    refactoring

commit fca4dbb8cae65b4e6aab1f6863e3184f130eae5c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 13 18:40:27 2025 -0500

    debhelper uses '|| true' for systemctl start action so we should too.

commit e5224a29ef671ac1fcafafeb2f1e0151cd7a4cae
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Feb 11 23:56:29 2025 -0600

    Fix upgrade failure caused by premature server start on first install

commit 3628408f2b3b8b49b2d4051b183a87181035dbe6
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Feb 10 17:45:09 2025 -0600

    Don't error out if trying to create a socket for a persistent user who isn't also an explicitly allowed user

commit 4d7058f03bba3d11adb818ca31ac9fea25a23c12
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Feb 10 11:18:56 2025 +0000

    bumped changelog version

commit 8061b893ac26b5d35653839e07a660b604fa3d97
Merge: 3d28f93 d244187
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Feb 10 06:14:52 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit d244187a8b83cdcda0b3f1132444292b7e4486af
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Feb 9 15:20:30 2025 -0600

    Add crash recovery, polish comm socket autocreation, add allowed-users configuration option

commit 3d28f938910c5d98e9adf2aeff6ddfa9b8ba0fc1
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Feb 9 10:03:56 2025 +0000

    bumped changelog version

commit 64238cffacb8b74930d7f98bbf365075c356f87c
Merge: cab7f1a 108871e
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sun Feb 9 04:50:55 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 108871e9914e138bbb05b84e32ae497888f26b15
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 8 23:57:28 2025 -0600

    Fix up systemd restart support

commit cab7f1a82d193819b89d3709bdd94677cb054997
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 11:29:31 2025 +0000

    bumped changelog version

commit d25df76a304d173c51e194fa00db1419af406a36
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:26:37 2025 -0500

    comment

commit d2e2a34c391558fbaf977794d91a358d06109a64
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:17:01 2025 -0500

    comment

commit 899e20b5b9c327a3cdc551ef2bb2c16fe813bed6
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:15:28 2025 -0500

    chmod +x

commit cda7165d040c5ac595539a24420b4b96b0a01979
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:14:35 2025 -0500

    comment

commit 4a3714758cead75b642dd0839293a6f6e5b1de35
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:14:14 2025 -0500

    .

commit e5d13f23f308cab1ca7ecb85f7c267f5fcfa0154
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:13:08 2025 -0500

    minor

commit 94d8659f61bc0500b2f557ad06ffbb26f554eccb
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:12:29 2025 -0500

    let `#DEBHELPER#` restart privleap before re-creating privleap sockets

commit 253d3aa317a2e31dba1ce188b8d7c402dbce7310
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:07:24 2025 -0500

    minor

commit e2537eec4a2fd279909267998c25fb4a649e5811
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:07:00 2025 -0500

    refactoring

commit 571c06eb5e6d0ada72c0ca2c044db6ac24f8483c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:05:26 2025 -0500

    avoid `which` and assume `systemctl` is available

commit 3c2c14ed5dc6920408c09cb7a8659f36bf3d88ba
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 06:00:55 2025 -0500

    disable manual and likely unneeded systemctl restart to fix lintian warning

commit fe5ccebedad6789abde35c31e87315745d2f0b87
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 10:49:44 2025 +0000

    bumped changelog version

commit 1c3b56605ccbf6530f8128ea0eab4327aa7d8567
Merge: 30db2fd 6f24165
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 8 05:40:44 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 6f24165230db765b50194db20d62eebdc096994a
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 7 15:15:18 2025 -0600

    Add dpkg trigger for automatically restarting privleapd when new configuration is installed

commit eb372e470b97b2dce1b3063ffdff236784a52673
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 7 14:15:39 2025 -0600

    Use systemd executable prefix instead of a shell to prevent privleapd start failure from preventing login

commit 30db2fd12d3db6b6f1d84961e5457e033beb5c7a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 7 11:17:21 2025 +0000

    bumped changelog version

commit a0df48709aea3f3b917954ed2b1a90626659cd21
Merge: f5b55c1 daa0487
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Feb 7 06:15:13 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit daa048708f1bd45193ff910f535f70b792e36cf1
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Feb 7 00:01:44 2025 -0600

    Fix a mypy gripe

commit 7b744f89862c0ca64867a411ff19b63857ffadcf
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 6 23:55:19 2025 -0600

    Add invalid ASCII testing, close the stdin stream of child processes upon creation

commit 0b80a23c8d1668ccab8ca39fa9a9e2f279766f54
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 6 21:31:31 2025 -0600

    Avoid login failure if privleap is unable to start, add test for command lines with multiple equals signs

commit d20f9aa2f6332c112de4b79f06dd4b74cba80f30
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 6 21:17:53 2025 -0600

    Prevent crashes if an authorized user or group does not exist

commit f5b55c154febbae7678fa81cd6618d7a71ab8f8f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 6 17:16:14 2025 +0000

    bumped changelog version

commit 556d4371f6e83f67e3b8dad68c6424de3f230275
Merge: dec939e e81c890
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Feb 6 12:16:00 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit e81c89099cba6594b4d9e3763dc9e1e5a205fd39
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Feb 6 10:28:02 2025 -0600

    Fix typo, correct incorrect ASCII checks

commit dec939e01bff3557fec5f865e34060b1f19154b1
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Feb 4 09:48:35 2025 +0000

    bumped changelog version

commit ee1e7b8a172b107201464621634f62c12fb2438f
Merge: 6690263 fb3a359
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Mon Feb 3 06:16:11 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit fb3a3590d48647a9ae49d17ead4fd8cf91c453be
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Feb 2 21:51:39 2025 -0600

    Allow multiple users and groups to be authorized to run one action, polish tests

commit cff5981eb763e670bb12806f588cc61738379050
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Feb 2 14:34:40 2025 -0600

    Fix botched function call, add test to catch similar issues in the future

commit 1520ed870c46611c9e783695016365c9c58c86c0
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Feb 2 13:35:22 2025 -0600

    Polish tests and code further, ensure that UIDs/GIDs work in places where user names and group names are expected

commit 9ddf886fa56800281d85120071d9525f7853f4a8
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Feb 2 00:05:35 2025 -0600

    (wip) Allow UIDs and GIDs to be used anywhere usernames or group names would be accepted

commit 18712266d1f6d2f2c8eb9a473b04eccab5adc724
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 1 20:52:19 2025 -0600

    Add support for persistent users, simplify simple message classes

commit 48532969f7ff44aeb0eafda3823e90478c611f7f
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Feb 1 19:53:18 2025 -0600

    Allow root to run all actions

commit 669026342a24e8a36d6e396441f9446ea36ff2f3
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Sat Feb 1 13:38:37 2025 +0000

    bumped changelog version

commit 1d52d0e33cb5bd850e06c7cb211979379060beaa
Merge: ec31cc1 6b87a13
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Jan 31 14:45:47 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 6b87a132d480c695874fe7e3c9e62aae30098f13
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Jan 30 23:19:24 2025 -0600

    More readability and security improvements, remove obsolete test plan file

commit ec31cc180f4d9787779a0ad27f0168040652a76f
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 30 16:43:51 2025 +0000

    bumped changelog version

commit b053c19918f936036c5c0d969f6857bedc4cbb5c
Merge: 5cbeeb9 28a4f89
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 30 11:33:25 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 28a4f89c0fa977f0dbaad20b267c3342d3652ac5
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 29 21:55:11 2025 -0600

    Clarify a couple of comments

commit 5d634a423aad3eae0d8f8c1673608bd64576172c
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 29 21:52:38 2025 -0600

    Remove unneeded action_name parameters in messages, use an int for exit code handling

commit 04f1d068df5affa253a54191cc43dbf9ee0423d0
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 29 21:34:41 2025 -0600

    privleapd: set SHELL in child processes, set the current working directory properly

commit 1434245e39e9ffb4ad31ae8a76f86d442398694b
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 29 21:00:16 2025 -0600

    Re-enable previously failing tests, fix pylint gripes

commit 5845034c68f42ebd65331ea72ddeff075e59f8d4
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 29 20:26:31 2025 -0600

    Make tests more robust, add test log header and summary

commit 5cbeeb9a9765128f50550221b69a5e50702ed9ce
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jan 29 14:02:47 2025 +0000

    bumped changelog version

commit 22416f2c2eb1056ae8111bdea5851ce7faef2ba4
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jan 29 09:02:33 2025 -0500

    changelog

commit cc6ee464acebf619a56b32625c4e0a31aefbbd2a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jan 29 13:13:32 2025 +0000

    bumped changelog version

commit 4af5d30a429933f25c36d14333540cf63330d5c5
Merge: 2ba6007 244c062
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jan 29 08:07:51 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 244c0626f20b4138731867e75e2249c5a280b023
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 29 00:13:24 2025 -0600

    Implement more tests, add autopkgtest support, fix test bugs

commit 2ba6007fbf01bd6c747a1c106f265348a7f31ce5
Merge: a9f9403 c688060
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Tue Jan 28 14:09:58 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit c6880608fab0d57ef6eb9133f2985242413b0aac
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Mon Jan 27 22:21:10 2025 -0600

    Add more tests for privleapd, refactor tests (wip)

commit 205a56b02bf8032e36551d1edcdf62863efd4f27
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Jan 26 18:40:40 2025 -0600

    Add unit tests (wip)

commit d0159f0da4e7873ae127681063dfb807cf7bf6fa
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Jan 26 11:41:56 2025 -0600

    Use logging rather than print in privleapd

commit 5e56987b0a7f543ad84c7d2b57bb21913ec5ffef
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sat Jan 25 23:13:19 2025 -0600

    Extensive post-review refactoring

commit a9f940338959e7719eafe0046595ab008b04881b
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Jan 24 13:29:42 2025 +0000

    bumped changelog version

commit 765c472871d3a8675404f5780b6e0af0f3de954f
Merge: aaedc49 9353c5a
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Fri Jan 24 08:29:27 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 9353c5a4449c26a808a3681eae5aeee9b79c7e04
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Jan 24 00:53:10 2025 -0600

    Make code PyLint-compliant (wip)

commit 626c06651a28162fac3122fa79e4c1d1a0e7b441
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Thu Jan 23 21:08:02 2025 -0600

    Add detailed type annotations to pass mypy (untested)

commit aaedc494bc07d133c4f278ae7b5c0d9af907f2bb
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 23 16:26:21 2025 +0000

    bumped changelog version

commit e4d79b08facd849584e8085908ef90818c0b90eb
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 23 11:12:05 2025 -0500

    copyright

commit 24a8887ffc5491eabb6deb60ccc2f0de00ef1a24
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 23 14:51:55 2025 +0000

    bumped changelog version

commit 5d85b477403bbe0ed98ec73903c0419ca92ff222
Merge: ea6c142 4823d3c
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Thu Jan 23 09:34:59 2025 -0500

    Merge remote-tracking branch 'ArrayBolt3/master'

commit 4823d3ca8d5e11e41d230dcec4a486e8670c275d
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 22 22:21:17 2025 -0600

    Fix readme, allow numbers in action names, fix environment and threading bugs

commit c18cc94cd29c66cdaa8e0d059c0250ff089bc4bd
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 22 19:19:25 2025 -0600

    Automatically handle leapctl user socket management, fix systemd unit bug

commit 8ea08423bbb318c505683b3f51e2383b82aebef2
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 22 17:06:47 2025 -0600

    Fix a logic error with stdio streaming, allow multiple actions to be defined in one file

commit 6c653e64da4959de2b53b72ec49835c01808204b
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 22 14:14:03 2025 -0600

    Greatly improve input validation, trim unneeded code and commented-out code

commit ea6c142117d8982f54e1259433c730b8d3f94a28
Author: Patrick Schleizer <adrelanos@whonix.org>
Date:   Wed Jan 22 14:39:25 2025 +0000

    bumped changelog version

commit 95618b825baefb8216ae502ac993ea0628c4d202
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Wed Jan 22 00:26:02 2025 -0600

    Allow streaming stdout and stderr, don't drop the entire server's privileges when spawning a process

commit 8b0a3899d739919adc943cd6273c2aab58f72ccc
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Tue Jan 21 22:58:44 2025 -0600

    Allow running actions as users other than root, handle launch-time errors gracefully

commit c1b6cf4a7e5c91249c983153b5dfd38bb7c70573
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Jan 19 15:45:30 2025 -0600

    Fix README

commit 9f130920d95ba64f74f81aeadd485ac32f8e392f
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Jan 19 15:42:29 2025 -0600

    More bugfixes and polishing after testing and stress-testing

commit 80ce8a040dd0fbaaf601c053a1730b5882286279
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Jan 19 01:43:19 2025 -0600

    Various improvements

commit 437146297eecf82beb26b149b79daa62cfcb983a
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Sun Jan 19 00:39:21 2025 -0600

    Bugfixes, add leapctl and leaprun code, polish readme

commit d52eb866f9c5241942c5ff971a19ae71f1b13b3a
Author: Aaron Rainbolt <arraybolt3@ubuntu.com>
Date:   Fri Jan 17 16:45:42 2025 -0600

    Initial commit, very incomplete
